C     ---------------------
      SUBROUTINE CHEAD1(NN)
C     ---------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 CHEAD(MAXCHN),CCHRH(MAXNN),CCHLH(MAXNN),H(MAXNN),
     1   QCH(MAXCHN),K(MAXCHN),B(MAXCHN),
     2   AREA(MAXCHN),CHEAD0(MAXCHN)
      REAL*8 TTAB(MAXCHN,MAXTAB),CHTAB(MAXCHN,MAXTAB),XCHTAB(MAXCHN)
      REAL*8 QPOS(MAXNN),QNEG(MAXNN)
      INTEGER*2 CHNODE(MAXCHN),TYPE(MAXCHN),TABLE(MAXCHN),NPT(MAXCHN)
      IR1=11
      IW1=13
C
C     BEGIN DATA INPUT
C     CONSTANT-HEAD NODES AND WATER-LEVEL VALUES
C
      WRITE(*,'(1X,''READING IN CHEAD'')')
      READ(IR1,900) NCHN,IECHO1,IECHO2
      WRITE(IW1,901) NCHN,IECHO1,IECHO2
      IF (NCHN.EQ.0) RETURN
      READ(IR1,902) (CHNODE(I),CHEAD0(I),K(I),B(I),AREA(I),
     1   TYPE(I),TABLE(I),I=1,NCHN)
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,903)
      WRITE(IW1,904) (CHNODE(I),CHEAD0(I),K(I),B(I),AREA(I),
     1   TYPE(I),TABLE(I),I=1,NCHN)
      ENDIF
      DO 120 I=1,NCHN
      K(I)=K(I)/(24.0*3600.0)
 120  CONTINUE
 900  FORMAT(3I10)
 901  FORMAT(/1X,'CONSTANT-HEAD NODES'/1X,19('-')/
     1   1X,'NUMBER OF NODES                         ',I10/
     2   1X,'SWITCH FOR ECHO OF INPUT HEADS          ',I10/
     3   1X,'SWITCH FOR ECHO OF STEP FLUXES          ',I10)
 902  FORMAT(I10,4F10.0,2I10)
 903  FORMAT(/1X,6X,'NODE',6X,'HEAD',9X,'K',9X,'B',6X,'AREA',
     1   6X,'TYPE',5X,'TABLE'/)
 904  FORMAT(1X,I10,0PF10.2,1PE10.2,1PE10.2,1PE10.2,2I10)
C
C     CONSTANT-HEAD TABLES
C
      READ(IR1,951) NTABLE
      IF (NTABLE.NE.0) THEN
      DO 351 ITABLE=1,NTABLE
      READ(IR1,952) NPT(ITABLE)
      READ(IR1,953) (TTAB(ITABLE,IPT),CHTAB(ITABLE,IPT),IPT=1,
     1   NPT(ITABLE))
      WRITE(IW1,954) ITABLE
      WRITE(IW1,955) (IPT,TTAB(ITABLE,IPT),CHTAB(ITABLE,IPT),IPT=1,
     1   NPT(ITABLE))
 351  CONTINUE
      ENDIF
 951  FORMAT(I10)
 952  FORMAT(I10)
 953  FORMAT(2F10.0)
 954  FORMAT(/1X,'CONSTANT-HEAD TABLE',I10/1X,29('-')//
     1   1X,5X,'POINT',6X,'TIME',6X,'HEAD'/)
 955  FORMAT((1X,I10,2F10.2))
      RETURN
C
C     END OF DATA INPUT
C
C     -----------------------------------------------
      ENTRY CHEAD2(CCHRH,CCHLH,H,STIME,SUMCH,IOUT,NN)
C     -----------------------------------------------
C
C     INITIALIZE VECTORS (CCHRH) AND (CCHLH)
C
      DO 100 I=1,NN
      CCHRH(I)=0.0
      CCHLH(I)=0.0
 100  CONTINUE
      SUMCH=0.0
      IF (NCHN.EQ.0) RETURN
C
C     CONSTANT HEADS FROM TABLES
C
      IF (NTABLE.NE.0) THEN
      DO 361 ITABLE=1,NTABLE
      IF (STIME.LE.TTAB(ITABLE,1)) THEN
      XCHTAB(ITABLE)=CHTAB(ITABLE,1)
      GOTO 361
      ENDIF
      IF (STIME.GE.TTAB(ITABLE,NPT(ITABLE))) THEN
      XCHTAB(ITABLE)=CHTAB(ITABLE,NPT(ITABLE))
      GOTO 361
      ENDIF
      DO 360 IPT=2,NPT(ITABLE)
      IF (STIME.LE.TTAB(ITABLE,IPT)) THEN
      CH1=CHTAB(ITABLE,IPT-1)
      CH2=CHTAB(ITABLE,IPT)
      T1=TTAB(ITABLE,IPT-1)
      T2=TTAB(ITABLE,IPT)
      XCHTAB(ITABLE)=CH1+(CH2-CH1)*(STIME-T1)/(T2-T1)
      GOTO 361
      ENDIF
 360  CONTINUE
 361  CONTINUE
      ENDIF
C
C     COMPUTE LEFT-HAND AND RIGHT-HAND COEFFICIENTS
C
      DO 101 I=1,NCHN
C
      J=CHNODE(I)
      ITABLE=TABLE(I)
      IF (ITABLE.NE.0) CHEAD(I)=CHEAD0(I)+XCHTAB(ITABLE)
      IF (ITABLE.EQ.0) CHEAD(I)=CHEAD0(I)
      DIFF=CHEAD(I)-H(J)
C
      IF (TYPE(I).EQ.0) THEN
      CCHLH(J)=AREA(I)*K(I)/B(I)
      CCHRH(J)=AREA(I)*K(I)*CHEAD(I)/B(I)
      GOTO 101
      ENDIF
C
      IF (TYPE(I).EQ.1) THEN
      IF (DIFF.LE.B(I)) THEN
      CCHLH(J)=AREA(I)*K(I)/B(I)
      CCHRH(J)=AREA(I)*K(I)*CHEAD(I)/B(I)
      GOTO 101
      ELSE
      CCHLH(J)=0.0
      CCHRH(J)=AREA(I)*K(I)
      GOTO 101
      ENDIF
      ENDIF
C
      IF (TYPE(I).EQ.2) THEN
      IF (DIFF.LE.0.0) THEN
      CCHLH(J)=AREA(I)*K(I)/B(I)
      CCHRH(J)=AREA(I)*K(I)*CHEAD(I)/B(I)
      GOTO 101
      ELSE
      CCHLH(J)=0.0
      CCHRH(J)=0.0
      GOTO 101
      ENDIF
      ENDIF
C
 101  CONTINUE
      RETURN
C     ---------------------------------------------------
      ENTRY CHEAD3(CCHRH,CCHLH,H,QPOS,QNEG,SUMCH,IOUT,NN)
C     ---------------------------------------------------
C
C     COMPUTE CONSTANT-HEAD FLUXES AND DISPLAY RESULTS
C
      SUMCH=0.0
      IF (NCHN.EQ.0) RETURN
      DO 150 I=1,NCHN
      J=CHNODE(I)
      QCH(I)=CCHRH(J)-CCHLH(J)*H(J)
      IF (QCH(I).GE.0.0) QPOS(J)=QPOS(J)+QCH(I)
      IF (QCH(I).LT.0.0) QNEG(J)=QNEG(J)+QCH(I)
      SUMCH=SUMCH+QCH(I)
 150  CONTINUE
      IF (IECHO2.EQ.1 .AND. IOUT.EQ.1) THEN
      WRITE(IW1,905) SUMCH
      WRITE(IW1,906) (CHNODE(I),CHEAD(I),H(CHNODE(I)),
     1   QCH(I),I=1,NCHN)
      ENDIF
 905  FORMAT(/1X,'CONSTANT-HEAD NODES'/1X,19('-')/
     1   1X,'CUMULATIVE RATE',1PE10.2/
     2   1X,6X,'NODE',5X,'CHEAD',9X,'H',6X,'RATE'/)
 906  FORMAT(1X,I10,0PF10.2,0PF10.2,1PE10.2)
      RETURN
      END
