C     --------------------
      SUBROUTINE EVAP1(NN)
C     --------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 ETAREA(MAXETN),LAND(MAXETN),H0ET(MAXETN),QET(MAXETN),
     1   CETRH(MAXNN),CETLH(MAXNN),H(MAXNN),FACSET(MAXSTP),
     2   DELH0(MAXETN),ETMAX(MAXETN)
      REAL*8 QPOS(MAXNN),QNEG(MAXNN)
      INTEGER*2 ETNODE(MAXETN)
      IR1=11
      IW1=13
C
C     NUMBER OF ETNODES
C
      WRITE(*,'(1X,''READING IN EVAP'')')
      READ(IR1,900) NETN,MAXKNS,IECHO1,IECHO2
      WRITE(IW1,901) NETN,MAXKNS,IECHO1,IECHO2
      IF (NETN.EQ.0) RETURN
 900  FORMAT(4I10)
 901  FORMAT(/1X,'EVAPOTRANSPIRATION'/1X,18('-')/
     1   1X,'NUMBER OF NODES                         ',I10/
     2   1X,'NUMBER OF TIME STEPS                    ',I10/
     3   1X,'SWITCH FOR ECHO OF INPUT DATA           ',I10/
     4   1X,'SWITCH FOR ECHO OF FLUXES               ',I10)
C
C     ET NODES, AREA (ACRES), LAND-SURFACE ALTITUDE (FEET)
C
      READ(IR1,902) (ETNODE(I),ETAREA(I),LAND(I),DELH0(I),
     1   ETMAX(I),I=1,NETN)
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,903)
      WRITE(IW1,904) (ETNODE(I),ETAREA(I),LAND(I),DELH0(I),
     1   ETMAX(I),I=1,NETN)
      ENDIF
 902  FORMAT(I10,4F10.0)
 903  FORMAT(/1X,6X,'NODE',6X,'AREA',6X,'LAND',5X,'DELH0',
     1   5X,'ETMAX'/)
 904  FORMAT(1X,I10,0PF10.2,0PF10.2,0PF10.2,1PE10.2)
C
C     TIME-SET MULTIPLIERS
C
      READ(IR1,910) (FACSET(I),I=1,MAXKNS)
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,911)
      WRITE(IW1,912) (I,FACSET(I),I=1,MAXKNS)
      ENDIF
 910  FORMAT(10X,F10.0)
 911  FORMAT(/1X,'TIME-STEP MULTIPLIERS'/1X,21('-')/
     1   1X,4X,'STEP',4X,'FACTOR'/)
 912  FORMAT(1X,I10,1PE10.2)
C
C     ADJUST LAND ALTITUDES TO REPRESENT ZERO-ET ALTITUDE
C
      DO 101 I=1,NETN
      ETAREA(I)=ETAREA(I)*43560.0
      H0ET(I)=LAND(I)-DELH0(I)
      ETMAX(I)=ETMAX(I)/(365.0*24.0*3600.0)
 101  CONTINUE
      RETURN
C
C     END OF DATA INPUT
C
C     --------------------------------------------
      ENTRY EVAP2(CETRH,CETLH,H,SUMET,KNS,IOUT,NN)
C     --------------------------------------------
C
C     INITIALIZE VECTORS (CETRH) AND (CETLH)
C
      DO 100 I=1,NN
      CETRH(I)=0.0
      CETLH(I)=0.0
 100  CONTINUE
      IF (NETN.EQ.0) RETURN
C
C     COMPUTE LEFT-HAND AND RIGHT-HAND COEFFICIENTS
C
      DO 110 I=1,NETN
      J=ETNODE(I)
      IF (H(J).LE.H0ET(I)) THEN
      CETRH(J)=0.0
      CETLH(J)=0.0
      ELSE
      COEF=ETAREA(I)*ETMAX(I)*FACSET(KNS)/DELH0(I)
      CETRH(J)=COEF*H0ET(I)
      CETLH(J)=COEF
      ENDIF
 110  CONTINUE
      RETURN
C
C     ------------------------------------------------------
      ENTRY EVAP3(CETRH,CETLH,H,QPOS,QNEG,SUMET,KNS,IOUT,NN)
C     ------------------------------------------------------
C
C     COMPUTE ET FLUXES AND DISPLAY RESULTS
C
      SUMET=0.0
      IF (NETN.EQ.0) RETURN
      DO 120 I=1,NETN
      J=ETNODE(I)
      QET(I)=CETRH(J)-CETLH(J)*H(J)
      IF (QET(I).GE.0.0) QPOS(J)=QPOS(J)+QET(I)
      IF (QET(I).LT.0.0) QNEG(J)=QNEG(J)+QET(I)
      SUMET=SUMET+QET(I)
 120  CONTINUE
      IF (IECHO2.EQ.1 .AND. IOUT.EQ.1) THEN
      WRITE(IW1,950) SUMET
      WRITE(IW1,951) (ETNODE(I),LAND(I)-H(ETNODE(I)),QET(I),I=1,NETN)
      ENDIF
 950  FORMAT(/1X,'EVAPOTRANSPIRATION'/1X,18('-')/
     1   1X,'CUMULATIVE RATE',1PE10.2/
     2   1X,6X,'NODE',5X,'DEPTH',6X,'RATE'/)
 951  FORMAT(1X,I10,0PF10.2,1PE10.2)
      RETURN
      END
