C     ---------------------
      SUBROUTINE RIVER1(NN)
C     ---------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 PARAMX(MAXPAR),KBED0(MAXRCH,MAXRIV)
      INTEGER*2 INDRIV(MAXRCH,MAXRIV)
      REAL*8 HBED(MAXRCH,MAXRIV),LENGTH(MAXRCH,MAXRIV),
     1   KBED(MAXRCH,MAXRIV),BBED(MAXRCH,MAXRIV),QRIV(MAXRCH,MAXRIV),
     2   FACA(MAXRCH,MAXRIV)
      REAL*8 CRRH(MAXNN),CRLH(MAXNN),H(MAXNN),KFACT
      REAL*8 QIN(MAXINF,MAXSTP)
      REAL*8 XSUMQ1(MAXRCH,MAXRIV),XSUMQ2(MAXRCH,MAXRIV),
     1   XSUMQ3(MAXRCH,MAXRIV),XSUMQ4(MAXRCH,MAXRIV),
     2   XSUMQ5(MAXRCH,MAXRIV)
      INTEGER*2 RNODE(MAXRCH,MAXRIV),SET(MAXRCH,MAXRIV),NRN(MAXRCH),
     1   JOIN(MAXRCH,MAXRIV),ICOEF(MAXRCH,MAXRIV),ITABLE(MAXRCH,MAXRIV)
      REAL*8 QTAB(MAXSEC,MAXPTS),WTAB(MAXSEC,MAXPTS),DTAB(MAXSEC,MAXPTS)
      REAL*8 QPOS(MAXNN),QNEG(MAXNN)
      INTEGER*2 NPT(MAXSEC)
      IR1=11
      IW1=13
C
C     NUMBER OF RIVER NODES, TRIBUTARY NODES, AND TIME STEPS
C
      READ(IR1,900) NRCH,NINF,NSTEP,IECHO1,IECHO2,IECHO3
      IF (NRCH.EQ.0) RETURN
C
C     CHANNEL GEOMETRY
C
      READ(IR1,901) AD,BD,AW,BW
      WRITE(IW1,920) NRCH,NINF,NSTEP,IECHO1,IECHO2,IECHO3
      IF (IECHO1.EQ.1) WRITE(IW1,902) AD,BD,AW,BW
 900  FORMAT(6I10)
 901  FORMAT(4F10.0)
 920  FORMAT(/1X,'STREAM-AQUIFER INTERACTION'/1X,26('-')//
     1   1X,'NUMBER OF CHANNEL REACHES     ',I10/
     2   1X,'NUMBER OF INFLOWS             ',I10/
     3   1X,'NUMBER OF TIME STEPS          ',I10/
     5   1X,'ECHO CHANNEL SPECIFICATIONS   ',I10/
     6   1X,'ECHO CHANNEL INFLOWS          ',I10/
     7   1X,'ECHO CHANNEL FLOWS            ',I10)
 902  FORMAT(/1X,'DEPTH COEFFICIENT             ',1PE10.2/
     2   1X,'DEPTH EXPONENT                ',1PE10.2/
     3   1X,'WIDTH COEFFICIENT             ',1PE10.2/
     4   1X,'WIDTH EXPONENT                ',1PE10.2)
C
C     RIVER NODES, ALTITUDE OF RIVER BED, REACH LENGTH,
C        CHANNEL-BED LEAKANCE, INFLOW IDENTIFIER
C
      DO 100 IRCH=1,NRCH
      READ(IR1,922) NRN(IRCH),KFACT
      READ(IR1,903) (RNODE(IRCH,I),HBED(IRCH,I),LENGTH(IRCH,I),
     1   KBED0(IRCH,I),BBED(IRCH,I),JOIN(IRCH,I),SET(IRCH,I),
     2   ITABLE(IRCH,I),INDRIV(IRCH,I),I=1,NRN(IRCH))
 100  CONTINUE
      DO 1001 IRCH=1,NRCH
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,904) IRCH,KFACT
      WRITE(IW1,905) (RNODE(IRCH,I),HBED(IRCH,I),LENGTH(IRCH,I),
     1   KBED0(IRCH,I),BBED(IRCH,I),JOIN(IRCH,I),SET(IRCH,I),
     2   ITABLE(IRCH,I),INDRIV(IRCH,I),I=1,NRN(IRCH))
      ENDIF
      DO 1002 I=1,NRN(IRCH)
      KBED0(IRCH,I)=KBED0(IRCH,I)*KFACT/(24.0*3600.0)
 1002 CONTINUE
 1001 CONTINUE
 903  FORMAT(I10,4F10.0,4I10)
 904  FORMAT(/1X,'RIVER REACH         ',I10/1X,30('-')//
     1   1X,'FACTOR FOR BED PERMEABILITY',1PE10.2//
     2   1X,6X,'NODE',2X,'ALTITUDE',4X,'LENGTH',6X,'PERM',
     3   1X,'THICKNESS',3X,'JOINING',7X,'SET',5X,'TABLE'
     4   5X,'INDEX'/)
 905  FORMAT(1X,I10,2F10.2,1PE10.2,0PF10.2,4I10)
 922  FORMAT(I10,F10.0)
C
C     CHANNEL GEOMETRY TABLES
C
      READ(IR1,940) NTABLE
      DO 132 ITAB=1,NTABLE
      READ(IR1,942) NPT(ITAB)
      READ(IR1,943) (QTAB(ITAB,IPT),WTAB(ITAB,IPT),
     1   DTAB(ITAB,IPT),IPT=1,NPT(ITAB))
      IF (IECHO1.EQ.1) THEN
      WRITE(IW1,941) ITAB
      WRITE(IW1,944) (IPT,QTAB(ITAB,IPT),WTAB(ITAB,IPT),
     1   DTAB(ITAB,IPT),IPT=1,NPT(ITAB))
      ENDIF
 132  CONTINUE
 940  FORMAT(I10)
 941  FORMAT(/1X,'CHANNEL GEOMETRY TABLE',I8/1X,30('-')/
     1   1X,5X,'POINT',6X,'FLOW',5X,'WIDTH',5X,'DEPTH'/)
 942  FORMAT(I10)
 943  FORMAT(3F10.0)
 944  FORMAT(I10,3F10.1)
C
C     RIVER AND TRIBUTARY INFLOWS
C
      SUM=0.0
      DO 102 I=1,NINF
      READ(IR1,9071) RFACT
      READ(IR1,907) (QIN(I,J),J=1,NSTEP)
      DO 153 J=1,NSTEP
      QIN(I,J)=QIN(I,J)*RFACT
      SUM=SUM+QIN(I,J)
 153  CONTINUE
      SUM=SUM/NSTEP
      IF (IECHO2.EQ.1) THEN
      WRITE(IW1,908) I
      WRITE(IW1,909) (QIN(I,J),J=1,NSTEP)
      WRITE(IW1,9099) SUM
      ENDIF
 102  CONTINUE
 9071 FORMAT(F10.0)
 907  FORMAT(5F10.0)
 908  FORMAT(/1X,'INFLOW SET',I10/1X,20('-')/)
 909  FORMAT((1X,5F10.2))
 9099 FORMAT(/1X,'AVERAGE FLOW',F8.2)
      RETURN
C
C     END OF DATA INPUT
C
C     ----------------------------------------------
      ENTRY RIVER2(PARAMX,CRRH,CRLH,H,SUMR,ISTEP,NN)
C     ----------------------------------------------
C
C     ADJUST BED PERMEABILITY
C
      DO 3001 IRCH=1,NRCH
      DO 3002 I=1,NRN(IRCH)
      KBED(IRCH,I)=KBED0(IRCH,I)*DEXP(PARAMX(INDRIV(IRCH,I)))
 3002 CONTINUE
 3001 CONTINUE

C     INITIALIZE VECTORS (CRRH) AND (CRLH)
C
      DO 160 I=1,NN
      CRRH(I)=0.0
      CRLH(I)=0.0
 160  CONTINUE
      SUMR=0.0
      IF (NRCH.EQ.0) RETURN
C
C     ROUTE WATER IN RIVER AND COMPUTE RIGHT-HAND AND LEFT-HAND
C        COEFFICIENTS
C        Q1   INFLOW FROM UPSTREAM
C        Q2   INFLOW FROM TRIBUTARY
C        Q3   INFLOW FROM NON-TRIBUTARY
C        Q4   OUTFLOW THROUGH RIVER BED
C        Q5   OUTFLOW TO DOWNSTREAM
C
      DO 265 IRCH=1,NRCH
      DO 263 I=1,NRN(IRCH)
C
C     SET VALUES FOR KNOWN INFLOWS
C
      Q1=0.0
      IF (I.NE.1) Q1=QRIV(IRCH,I-1)
      Q2=0.0
      IF (JOIN(IRCH,I).NE.0) THEN
      JJ=JOIN(IRCH,I)
      II=NRN(JJ)
      Q2=QRIV(JJ,II)
      ENDIF
      Q3=0.0
      IF (SET(IRCH,I).NE.0) THEN
      JJ=SET(IRCH,I)
      Q3=QIN(JJ,ISTEP)
      ENDIF
      QSUM=Q1+Q2+Q3
      IF (QSUM.LT.0.0) QSUM=0.0
C
C     CHANNEL GEOMETRY FROM EXPONENTIAL RELATIONS
C
      IF (ITABLE(IRCH,I).EQ.0) THEN
      WIDTH=AW*QSUM**BW
      DEPTH=AD*QSUM**BD
      GOTO 149
      ENDIF
C
C     CHANNEL GEOMETRY FROM TABLE
C
      IF (ITABLE(IRCH,I).NE.0) THEN
      ITAB=ITABLE(IRCH,I)
C
      IF (QSUM.LE.QTAB(ITAB,1)) THEN
      WIDTH=WTAB(ITAB,1)
      DEPTH=DTAB(ITAB,1)
      GOTO 149
      ENDIF
C
      IF (QSUM.GE.QTAB(ITAB,NPT(ITAB))) THEN
      WIDTH=WTAB(ITAB,NPT(ITAB))
      DEPTH=DTAB(ITAB,NPT(ITAB))
      GOTO 149
      ENDIF
C
      DO 146 IPT=2,NPT(ITAB)
      IF (QSUM.GE.QTAB(ITAB,IPT-1) .AND. QSUM.LE.QTAB(ITAB,IPT)) THEN
      WIDTH=WTAB(ITAB,IPT-1)+(WTAB(ITAB,IPT)-WTAB(ITAB,IPT-1))*
     1   (QSUM-QTAB(ITAB,IPT-1))/(QTAB(ITAB,IPT)-QTAB(ITAB,IPT-1))
      DEPTH=DTAB(ITAB,IPT-1)+(DTAB(ITAB,IPT)-DTAB(ITAB,IPT-1))*
     1   (QSUM-QTAB(ITAB,IPT-1))/(QTAB(ITAB,IPT)-QTAB(ITAB,IPT-1))
      GOTO 149
      ENDIF
 146  CONTINUE
C
      ENDIF
 149  CONTINUE
      HEAD=HBED(IRCH,I)+DEPTH
      AREA0=WIDTH*LENGTH(IRCH,I)
C
C     COMPUTE LEAKAGE RATE AND MAXIMUM LEAKAGE RATE
C
      JJ=RNODE(IRCH,I)
      Q4=AREA0*KBED(IRCH,I)*(HEAD-H(JJ))/BBED(IRCH,I)
      QMAX=AREA0*KBED(IRCH,I)*(BBED(IRCH,I)+DEPTH)/BBED(IRCH,I)
C
C     CHECK FOR LEAKAGE RATE GREATER THAN INFLOW OR GREATER
C        THAN MAXIMUM RATE FOR UNIT GRADIENT
C
      IF (Q4.LT.0.0) THEN
      FACA(IRCH,I)=1.0
      AREA=AREA0*FACA(IRCH,I)
      Q4=Q4
      ICOEF(IRCH,I)=1
      GO TO 262
      ENDIF
C
      IF (QSUM.EQ.0.0) THEN
      FACA(IRCH,I)=0.0
      AREA=AREA0*FACA(IRCH,I)
      Q4=0.0
      ICOEF(IRCH,I)=2
      GO TO 262
      ENDIF
C
      IF (Q4.LE.DMIN1(QSUM,QMAX)) THEN
      FACA(IRCH,I)=1.0
      AREA=AREA0*FACA(IRCH,I)
      Q4=Q4
      ICOEF(IRCH,I)=3
      GO TO 262
      ENDIF
C
      IF (QSUM.LE.DMIN1(Q4,QMAX)) THEN
      FACA(IRCH,I)=QSUM/Q4
      AREA=AREA0*FACA(IRCH,I)
      Q4=QSUM
      ICOEF(IRCH,I)=4
      GO TO 262
      ENDIF
C
      IF (QMAX.LE.DMIN1(Q4,QSUM)) THEN
      FACA(IRCH,I)=1.0
      AREA=AREA0*FACA(IRCH,I)
      Q4=QMAX
      ICOEF(IRCH,I)=5
      GO TO 262
      ENDIF
C
 262  CONTINUE
      QRIV(IRCH,I)=QSUM-Q4
C
C     COMPUTE RIVER COEFFICIENTS
C
      JJ=RNODE(IRCH,I)
      IF (ICOEF(IRCH,I).LE.4) THEN
      CRLH(JJ)=AREA*KBED(IRCH,I)/BBED(IRCH,I)
      CRRH(JJ)=AREA*KBED(IRCH,I)*HEAD/BBED(IRCH,I)
      ENDIF
      IF (ICOEF(IRCH,I).EQ.5) THEN
      CRLH(JJ)=0.0
      CRRH(JJ)=Q4
      ENDIF
 263  CONTINUE
 265  CONTINUE
      RETURN
C
C     ---------------------------------------------------
      ENTRY RIVER3(CRRH,CRLH,H,QPOS,QNEG,SUMR,DELT,ISTEP,
     1   NSTEPX,IOUT,NN,IW20)
C     ---------------------------------------------------
C
      SUMR=0.0
      IF (NRCH.EQ.0) RETURN
      IF (ISTEP.EQ.1) THEN
      SRESID=0.0
      STIME=0.0
      DO 335 IRCH=1,NRCH
      DO 334 I=1,NRN(IRCH)
      XSUMQ1(IRCH,I)=0.0
      XSUMQ2(IRCH,I)=0.0
      XSUMQ3(IRCH,I)=0.0
      XSUMQ4(IRCH,I)=0.0
      XSUMQ5(IRCH,I)=0.0
 334  CONTINUE
 335  CONTINUE
      ENDIF
C
C     DISPLAY RIVER BUDGET COMPONENTS
C
      SUMQ3=0.0
      SUMQ4=0.0
      DO 167 IRCH=1,NRCH
      IF (IOUT.EQ.1 .AND. IECHO3.EQ.1) THEN
        WRITE(IW20,929) ISTEP
        WRITE(IW20,930) IRCH
      ENDIF
      DO 166 I=1,NRN(IRCH)
      Q1=0.0
      IF (I.NE.1) Q1=QRIV(IRCH,I-1)
      Q2=0.0
      IF (JOIN(IRCH,I).NE.0) THEN
      JJ=JOIN(IRCH,I)
      II=NRN(JJ)
      Q2=QRIV(JJ,II)
      ENDIF
      Q3=0.0
      IF (SET(IRCH,I).NE.0) THEN
      JJ=SET(IRCH,I)
      Q3=QIN(JJ,ISTEP)
      QSUM=Q1+Q2+Q3
      IF (QSUM.LT.0.0) Q3=-Q1-Q2
      ENDIF
      JJ=RNODE(IRCH,I)
      IF (ICOEF(IRCH,I).LE.4) Q4=CRRH(JJ)-CRLH(JJ)*H(JJ)
      IF (ICOEF(IRCH,I).EQ.5) Q4=CRRH(JJ)
      Q5=QRIV(IRCH,I)
      IF (Q4.GE.0.0) QPOS(JJ)=QPOS(JJ)+Q4
      IF (Q4.LE.0.0) QNEG(JJ)=QNEG(JJ)+Q4
      IF (IOUT.EQ.1 .AND. IECHO3.EQ.1) WRITE(IW20,931) RNODE(IRCH,I),
     1   Q1,Q2,Q3,Q4,Q5,ICOEF(IRCH,I)
C
C     CUMULATIVE RIVER BUDGET
C
      SUMQ3=SUMQ3+Q3
      SUMQ4=SUMQ4+Q4
      XSUMQ1(IRCH,I)=XSUMQ1(IRCH,I)+Q1
      XSUMQ2(IRCH,I)=XSUMQ2(IRCH,I)+Q2
      XSUMQ3(IRCH,I)=XSUMQ3(IRCH,I)+Q3
      XSUMQ4(IRCH,I)=XSUMQ4(IRCH,I)+Q4
      XSUMQ5(IRCH,I)=XSUMQ5(IRCH,I)+Q5
 166  CONTINUE
 167  CONTINUE
      SUMR=SUMQ4
C
C     DISPLAY DETAILED AVERAGE BUDGET
C
      IF (ISTEP.EQ.NSTEPX .AND. IOUT.EQ.1) THEN
      DO 267 IRCH=1,NRCH
      WRITE(IW20,9301) IRCH
      DO 266 I=1,NRN(IRCH)
      Q1=XSUMQ1(IRCH,I)/FLOAT(NSTEPX)
      Q2=XSUMQ2(IRCH,I)/FLOAT(NSTEPX)
      Q3=XSUMQ3(IRCH,I)/FLOAT(NSTEPX)
      Q4=XSUMQ4(IRCH,I)/FLOAT(NSTEPX)
      Q5=XSUMQ5(IRCH,I)/FLOAT(NSTEPX)
      WRITE(IW20,9311) RNODE(IRCH,I),Q1,Q2,Q3,Q4,Q5
 266  CONTINUE
 267  CONTINUE
      ENDIF
C
C     DISPLAY SUMMARY CUMULATIVE BUDGET
C
      Q5=QRIV(NRCH,NRN(NRCH))
      RESID=SUMQ3-SUMQ4-QRIV(NRCH,NRN(NRCH))
      SRESID=SRESID+RESID*DELT
      STIME=STIME+DELT
      IF (IOUT.EQ.1) WRITE(IW20,932) SUMQ3,SUMQ4,QRIV(NRCH,NRN(NRCH)),
     1   RESID,SRESID/STIME
 929  FORMAT(/1X,'TIME STEP ',I10)
 930  FORMAT(/1X,'SURFACE-WATER BUDGET COMPONENTS REACH   ',I10/
     1   1X,50('-')//
     2   1X,6X,'NODE',2X,'UPSTREAM',1X,'TRIBUTARY',4X,'INFLOW',
     3   2X,'RECHARGE',3X,'OUTFLOW',6X,'CODE'/)
 931  FORMAT(1X,I10,5F10.2,I10)
 9301  FORMAT(/1X,'AVERAGE SURFACE-WATER BUDGET COMPONENTS REACH     ',
     1   I10/1X,60('-')//
     2   1X,6X,'NODE',2X,'UPSTREAM',1X,'TRIBUTARY',4X,'INFLOW',
     3   2X,'RECHARGE',3X,'OUTFLOW'/)
 9311 FORMAT(1X,I10,5F10.2)
 932  FORMAT(/1X,'SURFACE-WATER BUDGET'/1X,20('-')//
     1   1X,'INFLOWS                       ',1PE10.2/
     2   1X,'OUTFLOW THROUGH RIVER BED     ',1PE10.2/
     3   1X,'OUTFLOW FROM LAST REACH       ',1PE10.2/
     4   1X,'RESIDUAL                      ',1PE10.2/
     5   1X,'CUMULATIVE RESIDUAL           ',1PE10.2)
 981  FORMAT(1X,I10,4F10.2)
      RETURN
      END