C     -----------------------
      SUBROUTINE SEARCH(IFIT)
C     -----------------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      REAL*8 PARAM0(MAXPAR),PARAMX(MAXPAR),PARAM(MAXPAR),
     1   UPAR(MAXPAR),VPAR(MAXPAR),WLM(MAXWL),WLC(MAXWL),
     2   LWLC(MAXWL),DELP(MAXPAR),WOBS(MAXWL),WEIGHT(MAXWL,3)
      REAL*8 LH(MAXPAR,MAXPAR),RH(MAXPAR),X(MAXWL,MAXPAR)
      INTEGER*2 IPARAM(MAXPAR),STEP(MAXWL),NODE(MAXWL,3)
      CHARACTER*60 FILE1,FILE2,XFILE(MAXFLS)
C
C     OPEN FILES
C
      IR0=10
      IR1=50
      IW1=51
      READ(IR0,9190) FILE1,NFILE
      IF (NFILE.GT.0) THEN
      READ(IR0,9191) (XFILE(I),I=1,NFILE)
      CALL FMERGE(XFILE,FILE1,NFILE)
      ENDIF
      READ(IR0,9191) FILE2
      OPEN (UNIT=IR1,FILE=FILE1,STATUS='OLD')
      OPEN (UNIT=IW1,FILE=FILE2,STATUS='UNKNOWN')
 9190 FORMAT(A60,I10)
 9191 FORMAT(A60)
C
C     READ PARAMETER SEARCH SPECIFICATIONS
C
      WRITE(*,'(1X,''READING IN SEARCH '',A60)') FILE1
      READ(IR1,900) NGBL,NPAR,NITER,PFACT,IOLS
      WRITE(IW1,902) NGBL,NPAR,NITER,PFACT,IOLS
      READ(IR1,904) (PARAM0(IPAR),IPARAM(IPAR),IPAR=1,NGBL)
      WRITE(IW1,906)
      WRITE(IW1,908) (IPAR,PARAM0(IPAR),IPARAM(IPAR),IPAR=1,NGBL)
      READ(IR1,910) (PARAM(IPAR),UPAR(IPAR),VPAR(IPAR),IPAR=1,NPAR)
      WRITE(IW1,912)
      DO 329 IPAR=1,NPAR
      IF (IOLS.NE.1) THEN
      WRITE(IW1,914) IPAR,PARAM(IPAR),UPAR(IPAR),VPAR(IPAR)
      ELSE
      WRITE(IW1,9141) IPAR,PARAM(IPAR),UPAR(IPAR),-999
      ENDIF
 329  CONTINUE
      READ(IR1,916) NOBS
      READ(IR1,920) (STEP(IOBS),(NODE(IOBS,I),WEIGHT(IOBS,I),I=1,3),
     1   WLM(IOBS),WOBS(IOBS),IOBS=1,NOBS)
      WRITE(IW1,918) NOBS
      DO 330 IOBS=1,NOBS
      IF (IOLS.NE.1) THEN
      WRITE(IW1,922) STEP(IOBS),(NODE(IOBS,I),WEIGHT(IOBS,I),I=1,3),
     1   WLM(IOBS),WOBS(IOBS)
      ELSE
      WRITE(IW1,9221) STEP(IOBS),(NODE(IOBS,I),WEIGHT(IOBS,I),I=1,3),
     1   WLM(IOBS),-999
      ENDIF
 330  CONTINUE
C
 900  FORMAT(3I10,F10.0,I10)
 902  FORMAT(1X,'SEARCH SPECIFICATION'/1X,20('-')/
     1   1X,'NUMBER OF GLOBAL PARAMETERS      ',I10/
     2   1X,'NUMBER OF ACTIVE PARAMETERS      ',I10/
     3   1X,'NUMBER OF ITERATIONS             ',I10/
     4   1X,'PERTURBATION FACTOR              ',1PE10.2/
     5   1X,'SWITCH FOR ORDINARY LEAST SQUARES',I10)
 904  FORMAT(10X,F10.0,I10)
 906  FORMAT(/1X,'GLOBAL PARAMETERS'/1X,17('-')//
     1   1X,4X,'GLOBAL',5X,'VALUE',4X,'ACTIVE'/
     2   1X,1X,'PARAMETER',11X,'PARAMETER'/)
 908  FORMAT(1X,I10,1PE10.2,I10)
 910  FORMAT(10X,3F10.0)
 912  FORMAT(/1X,'ACTIVE PARAMETERS'/1X,17('-')//
     1   1X,1X,'PARAMETER',3X,'INITIAL',2X,'EXPECTED',4X,'UNCER-'/
     2   1X,15X,'VALUE',5X,'VALUE',4X,'TAINTY'/)
 914  FORMAT(1X,I10,1PE10.2,1PE10.2,1PE10.2)
 9141 FORMAT(1X,I10,1PE10.2,1PE10.2,I10)
 916  FORMAT(I10)
 918  FORMAT(/1X,'MEASURED WATER LEVELS'/1X,22('-')/
     1   1X,'NUMBER OF OBSERVATIONS',I10//
     2   1X,6X,'STEP',3(6X,'NODE',4X,'WEIGHT'),5X,'LEVEL',4X,'UNCER-'/
     3   1X,84X,'TAINTY'/)
 920  FORMAT((I10,3(I10,F10.0),2F10.0))
 922  FORMAT(1X,I10,3(I10,F10.3),F10.2,F10.2)
 9221 FORMAT(1X,I10,3(I10,F10.3),F10.2,I10)
C
C     INVERT UNCERTAINTY VECTORS
C
      DO 130 I=1,NOBS
      IF (IOLS.NE.1) THEN
      WOBS(I)=1.0/(WOBS(I)**2)
      ELSE
      WOBS(I)=1.0
      ENDIF
 130  CONTINUE
      DO 132 I=1,NPAR
      IF (IOLS.NE.1) THEN
      VPAR(I)=1.0/(VPAR(I)**2)
      ELSE
      VPAR(I)=0.0
      ENDIF
 132  CONTINUE
C
C     BEGIN ITERATION LOOP
C
      IOUT=0
      ITER=0
 400  ITER=ITER+1
C
C     CONSTRUCT SENSITIVITY MATRIX
C     WATER LEVELS FOR UNPERTURBED PARAMETERS
C
      DO 140 IGBL=1,NGBL
      PARAMX(IGBL)=PARAM0(IGBL)
      II=IPARAM(IGBL)
      IF (II.NE.0) PARAMX(IGBL)=PARAMX(IGBL)+PARAM(II)
 140  CONTINUE
      IF (ITER.GT.NITER) GO TO 410
      ICODE=1
      CALL MODEL2(PARAMX,STEP,NODE,WEIGHT,LWLC,NOBS,ICODE,IOUT,IFIT)
C
C     SUM OF SQUARED RESIDUALS S0
C
      S0=0.0
      DO 192 J=1,NOBS
      S0=S0+(WLM(J)-LWLC(J))*WOBS(J)*(WLM(J)-LWLC(J))
 192  CONTINUE
      DO 194 J=1,NPAR
      S0=S0+(PARAM(J)-UPAR(J))*VPAR(J)*(PARAM(J)-UPAR(J))
 194  CONTINUE
      IF (ITER.EQ.1) WRITE(IW1,995) S0
C
C     WATER LEVELS FOR PERTURBED PARAMETERS
C
      DO 144 IPAR=1,NPAR
      DO 141 IGBL=1,NGBL
      PARAMX(IGBL)=PARAM0(IGBL)
      II=IPARAM(IGBL)
      IF (II.NE.0) THEN
      IF (II.NE.IPAR) THEN
      PARAMX(IGBL)=PARAMX(IGBL)+PARAM(II)
      ELSE
      PARAMX(IGBL)=PARAMX(IGBL)+PARAM(II)+DLOG(1.0+PFACT)
      ENDIF
      ENDIF
 141  CONTINUE
      ICODE=2
      CALL MODEL2(PARAMX,STEP,NODE,WEIGHT,WLC,NOBS,ICODE,IOUT,IFIT)
C
C     CONSTRUCT MATRIX
C
      DO 142 IOBS=1,NOBS
      X(IOBS,IPAR)=(WLC(IOBS)-LWLC(IOBS))/DLOG(1.0+PFACT)
 142  CONTINUE
 144  CONTINUE
C
C     CONSTRUCT LEFT-HAND SIDE
C
      DO 150 I=1,NPAR
      DO 148 L=1,NPAR
      LH(I,L)=0.0
      DO 145 J=1,NOBS
      LH(I,L)=LH(I,L)+X(J,I)*WOBS(J)*X(J,L)
 145  CONTINUE
 148  CONTINUE
      LH(I,I)=LH(I,I)+VPAR(I)
 150  CONTINUE
C
C     CONSTRUCT RIGH-HAND SIDE
C
      DO 154 I=1,NPAR
      RH(I)=0.0
      DO 151 J=1,NOBS
      RH(I)=RH(I)+X(J,I)*WOBS(J)*(WLM(J)-LWLC(J))
 151  CONTINUE
      RH(I)=RH(I)+VPAR(I)*(UPAR(I)-PARAM(I))
 154  CONTINUE
C
C     SOLVE FOR PARAMETER CHANGES
C
      CALL SOLEQU(LH,RH,DELP,NPAR)
C
C     ADJUSTMENTS TO STEP LENGTH
C     SUM OF SQUARED RESIDUALS S1
C
      ALPHA=1.0
      ICHG=0
 1601 CONTINUE
      ICHG=ICHG+1
      DO 191 IGBL=1,NGBL
      PARAMX(IGBL)=PARAM0(IGBL)
      II=IPARAM(IGBL)
      IF (II.NE.0) THEN
      PARAMX(IGBL)=PARAMX(IGBL)+(PARAM(II)+ALPHA*DELP(II))
      ENDIF
 191  CONTINUE
      ICODE=3
      CALL MODEL2(PARAMX,STEP,NODE,WEIGHT,WLC,NOBS,ICODE,IOUT,IFIT)
      S1=0.0
      DO 162 J=1,NOBS
      S1=S1+(WLM(J)-WLC(J))*WOBS(J)*(WLM(J)-WLC(J))
 162  CONTINUE
      DO 164 J=1,NPAR
      S1=S1+(PARAM(J)+ALPHA*DELP(J)-UPAR(J))*VPAR(J)*
     1   (PARAM(J)+ALPHA*DELP(J)-UPAR(J))
 164  CONTINUE
      IF (S0.LT.S1) THEN
      ALPHA=ALPHA*0.5
      IF (ALPHA.GE.0.01) GO TO 1601
      WRITE(IW1,996)
      GO TO 410
      ENDIF
      G=0.0
      DO 158 IPAR=1,NPAR
      G=G+DELP(IPAR)*RH(IPAR)
 158  CONTINUE
      A=1.1
      TEST=S0-ALPHA*G*(2.0-1.0/A)
      IF (S1.GE.TEST) THEN
      H=ALPHA*ALPHA*G/(S1-S0+2.0*ALPHA*G)
      ELSE
      H=ALPHA*A
      ENDIF
      DO 168 IPAR=1,NPAR
      PARAM(IPAR)=PARAM(IPAR)+H*DELP(IPAR)
 168  CONTINUE
C
C     OUTPUT RESULTS FOR ITERATION
C
      DO 170 IGBL=1,NGBL
      PARAMX(IGBL)=PARAM0(IGBL)
      II=IPARAM(IGBL)
      IF (II.NE.0) PARAMX(IGBL)=PARAMX(IGBL)+PARAM(II)
 170  CONTINUE
      ICODE=4
      CALL MODEL2(PARAMX,STEP,NODE,WEIGHT,LWLC,NOBS,ICODE,IOUT,IFIT)
C
C     SUM OF SQUARED RESIDUALS S0
C
      S2=0.0
      DO 1921 J=1,NOBS
      S2=S2+(WLM(J)-LWLC(J))*WOBS(J)*(WLM(J)-LWLC(J))
 1921 CONTINUE
      DO 1941 J=1,NPAR
      S2=S2+(PARAM(J)-UPAR(J))*VPAR(J)*(PARAM(J)-UPAR(J))
 1941 CONTINUE
      WRITE(IW1,950) ITER,ICHG,H,S2
      WRITE(IW1,952) (IPAR,PARAM(IPAR),H*DELP(IPAR),IPAR=1,NPAR)
 950  FORMAT(/1X,'SEARCH RESULTS'/1X,14('-')/
     1   1X,'ITERATION                      ',I10/
     2   1X,'NUMBER OF ADJUSTMENTS          ',I10/
     3   1X,'STEP ADJUSTMENT                ',1PE10.2/
     4   1X,'SUM OF SQUARED RESIDUALS       ',1PE10.2//
     5   1X,1X,'PARAMETER',5X,'VALUE',4X,'CHANGE'/)
 952  FORMAT(1X,I10,1PE10.2,1PE10.2)
 995  FORMAT(/1X,'SUM OF SQUARED RESIDUALS'/
     1   1X'FOR INITIAL VALUES             ',1PE10.2)
 996  FORMAT(/1X,'CALIBRATION TERMINATED - NEGLIGIBLE'/
     1   1X,'IMPROVEMENT IN REDUCING SUM OF SQUARES')
C
C     END ITERATION LOOP
C
      GO TO 400
 410  CONTINUE
C
C     OUTPUT SEARCH RESULTS
C
      IOUT=1
      ICODE=5
      CALL MODEL2(PARAMX,STEP,NODE,WEIGHT,WLC,NOBS,ICODE,IOUT,IFIT)
      WRITE(IW1,944)
      SEPS=0.0
      SSEPS=0.0
      DO 420 IOBS=1,NOBS
      EPS=WLM(IOBS)-WLC(IOBS)
      SEPS=SEPS+EPS
      SSEPS=SSEPS+EPS**2
      WRITE(IW1,946) STEP(IOBS),(NODE(IOBS,I),WEIGHT(IOBS,I),I=1,3),
     1   WLM(IOBS),WLC(IOBS),EPS
 420  CONTINUE
      SSEPS=SQRT(SSEPS/NOBS-SEPS**2/NOBS**2)
      SEPS=SEPS/NOBS
      WRITE(IW1,948) SEPS,SSEPS
C
 944  FORMAT(/1X,'FINAL WATER LEVELS'/1X,18('-')//
     1   1X,6X,'STEP',3(6X,'NODE',4X,'WEIGHT'),2X,'MEASURED',
     2   2X,'COMPUTED',2X,'RESIDUAL'/)
 946  FORMAT(1X,I10,3(I10,F10.3),3F10.2)
 948  FORMAT(/1X,'MEAN OF RESIDUALS              ',1PE10.2/
     1  1X,'STANDARD DEVIATION OF RESIDUALS',1PE10.2)
      STOP
      END