C     -----------------
      SUBROUTINE VFLUX1
C     -----------------
C
      INCLUDE 'PARAM.FOR'
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*2 (I-N)
      INTEGER*2 VFNODE(MAXVFB)
      REAL*8 K(MAXVFB),SS(MAXVFB),HEIGHT(MAXVFB),WIDTH(MAXVFB),
     1   QVF(MAXVFB)
      REAL*8 H(MAXNN),H0(MAXNN),QVFLUX(MAXNN),QVPAST(MAXNN),
     1   CVFRH(MAXNN),CVFLH(MAXNN)
      REAL*8 HSAVE(MAXVFB,MAXSTP),TIME(MAXSTP)
      REAL*8 QPOS(MAXNN),QNEG(MAXNN)
      IR1=11
      IW1=13
C
C     DATA INPUT
C
      WRITE(*,'(1X,''READING IN VFLUX'')')
      READ(IR1,900) NVFB,IECHO1,IECHO2
      WRITE(IW1,901) NVFB,IECHO1,IECHO2
      IF (NVFB.EQ.0)  RETURN
      IF (IECHO1.NE.0) WRITE(IW1,906)
      DO 100 IBX=1,NVFB
      READ(IR1,902) VFNODE(IBX),K(IBX),SS(IBX),WIDTH(IBX),
     1   HEIGHT(IBX)
      IF (IECHO1.NE.0) THEN
      WRITE(IW1,903) VFNODE(IBX),K(IBX),SS(IBX),WIDTH(IBX),
     1   HEIGHT(IBX)
      ENDIF
      K(IBX)=K(IBX)/(24.0*3600.0)
 100  CONTINUE
 900  FORMAT(3I10)
 901  FORMAT(/1X,'VARIABLE FLUX BOUNDARY NODES'/1X,28('-')/
     1   1X,'NUMBER OF VARIABLE FLUX NODES           ',I10/
     2   1X,'SWITCH FOR ECHO OF PARAMETERS           ',I10/
     3   1X,'SWITCH FOR ECHO OF FLUXES               ',I10)
 906  FORMAT(/1X,6X,'NODE',9X,'K',8X,'SS',5X,'WIDTH',4X,'HEIGHT'/)
 902  FORMAT(I10,4F10.0)
 903  FORMAT(1X,I10,0PF10.2,1PE10.2,0PF10.2,0PF10.2)
      RETURN
C
C     --------------------------------------------------
      ENTRY VFLUX2 (H0,H,QVPAST,CVFLH,CVFRH,DELT,SVFLUX,
     1   NN,KNS,ISS,IOUT)
C     ---------------------------------------------------
C
C     INITIALIZE ARRAYS
C
      DO 200 I=1,NN
      QVFLUX(I)=0.0
      QVPAST(I)=0.0
      CVFLH(I)=0.0
      CVFRH(I)=0.0
 200  CONTINUE
      IF (NVFB.EQ.0) RETURN
      IF(KNS.EQ.1.AND.ISS.EQ.1) RETURN
C
C     FILL TIME VECTOR
C
      IF (KNS-ISS.EQ.1) TIME(KNS)=DELT
      IF (KNS-ISS.GT.1) TIME(KNS)=TIME(KNS-1)+DELT
C
C     LOOP OVER BOUNDARY NODES
C
      DO 220 IBX=1,NVFB
      II=VFNODE(IBX)
      PI=3.14159
      FACTOR=K(IBX)*HEIGHT(IBX)*WIDTH(IBX)/
     1   SQRT(PI*K(IBX)/SS(IBX))
C
C     EFFECTS OF PAST STEPS
C
      SUMQ=0.0
      NIS=KNS-1
      IF (NIS.LT.1) GO TO 215
      DO 210 IS=1,NIS
      DELH=HSAVE(IBX,IS)-H0(II)
      T1=TIME(KNS-1)
      T2=TIME(KNS)
      IF (IS.GT.1) THEN
      T1=TIME(KNS-1)-TIME(IS-1)
      T2=TIME(KNS)-TIME(IS-1)
      ENDIF
C      T1=DABS(T2-DELT)
      SUMQ=SUMQ-2.0*FACTOR*DELH*(SQRT(T2)-SQRT(T1))/DELT
      T1=TIME(KNS-1)-TIME(IS)
      T2=TIME(KNS)-TIME(IS)
C      T1=DABS(T2-DELT)
      SUMQ=SUMQ+2.0*FACTOR*DELH*(SQRT(T2)-SQRT(T1))/DELT
 210  CONTINUE
      QVPAST(II)=SUMQ
C
C     EFFECTS OF PRESENT STEP
C
 215  CONTINUE
      T1=0.0
      T2=DELT
      CVFRH(II)=2.0*FACTOR*(SQRT(T2)-SQRT(T1))*H0(II)/DELT
      CVFLH(II)=2.0*FACTOR*(SQRT(T2)-SQRT(T1))/DELT
 220  CONTINUE
      RETURN
C
C     ------------------------------------------------
      ENTRY VFLUX3 (H0,H,QPOS,QNEG,QVPAST,CVFLH,CVFRH,
     1   DELT,SVFLUX,NN,KNS,ISS,IOUT)
C     ------------------------------------------------
C
      SVFLUX=0.0
      IF (NVFB.EQ.0) RETURN
      IF (KNS.EQ.1.AND.ISS.EQ.1) RETURN
      DO 300 IBX=1,NVFB
      II=VFNODE(IBX)
      HSAVE(IBX,KNS)=H(II)
      QVF(IBX)=CVFRH(II)-CVFLH(II)*H(II)
      SVFLUX=SVFLUX+QVF(IBX)+QVPAST(II)
      QVFLUX(II)=QVPAST(II)+QVF(IBX)
      IF (QVFLUX(II).GE.0.0) QPOS(II)=QPOS(II)+QVFLUX(II)
      IF (QVFLUX(II).LT.0.0) QNEG(II)=QNEG(II)+QVFLUX(II)
 300  CONTINUE
C
C     PRINT VARIABLE FLUXES
C
      IF (IECHO2.EQ.1 .AND. IOUT.EQ.1) WRITE(IW1,904) SVFLUX
      DO 301 IBX=1,NVFB
      II=VFNODE(IBX)
      IF (IECHO2.EQ.1 .AND. IOUT.EQ.1)
     1   WRITE(IW1,905) II,QVF(IBX),QVPAST(II),QVFLUX(II)
 301  CONTINUE
 904  FORMAT(/1X,'VARIABLE-FLUX NODES'/1X,19('-')/
     1   1X,'CUMULATIVE RATE     ',1PE10.2//
     2   1X,6X,'NODE',3X,'PRESENT',6X,'PAST',5X,'TOTAL'/)
 905  FORMAT(1X,I10,3(1PE10.2))
      RETURN
      END